[![CircleCI](https://circleci.com/gh/cucumber/common.svg?style=svg)](https://circleci.com/gh/cucumber/common)
[![OpenCollective](https://opencollective.com/cucumber/backers/badge.svg)](#backers) [![OpenCollective](https://opencollective.com/cucumber/sponsors/badge.svg)](#sponsors)
[![pull requests](https://www.oselvar.com/api/badge?label=pull+requests&csvUrl=https%3A%2F%2Fraw.githubusercontent.com%2Fcucumber%2Foselvar-github-metrics%2Fmain%2Fdata%2Fcucumber%2Fcommon%2FpullRequests.csv)](https://www.oselvar.com/github/cucumber/oselvar-github-metrics/main/cucumber/common '3rd quartile cycle time')
[![issues](https://www.oselvar.com/api/badge?label=issues&csvUrl=https%3A%2F%2Fraw.githubusercontent.com%2Fcucumber%2Foselvar-github-metrics%2Fmain%2Fdata%2Fcucumber%2Fcommon%2Fissues.csv)](https://www.oselvar.com/github/cucumber/oselvar-github-metrics/main/cucumber/common '3rd quartile cycle time')

# Cucumber Common Components

This repo contains the libraries/modules for behaviour that's common between the various Cucumber implementations. These include:

- [parsing Gherkin documents](https://github.com/cucumber/common/tree/main/gherkin) into a machine-readable object model.

Most of these modules have implemnentations in multiple langages, and use shared test suites to ensure behaviour is consistent. See the [contributing guide](https://github.com/cucumber/common/blob/master/CONTRIBUTING.md) for more details.

## Backers

Support us with a monthly donation and help us continue our activities. [[Become a backer](https://opencollective.com/cucumber#backer)]

<a href="https://opencollective.com/cucumber/backer/0/website" target="_blank"><img src="https://opencollective.com/cucumber/backer/0/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/backer/1/website" target="_blank"><img src="https://opencollective.com/cucumber/backer/1/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/backer/2/website" target="_blank"><img src="https://opencollective.com/cucumber/backer/2/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/backer/3/website" target="_blank"><img src="https://opencollective.com/cucumber/backer/3/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/backer/4/website" target="_blank"><img src="https://opencollective.com/cucumber/backer/4/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/backer/5/website" target="_blank"><img src="https://opencollective.com/cucumber/backer/5/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/backer/6/website" target="_blank"><img src="https://opencollective.com/cucumber/backer/6/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/backer/7/website" target="_blank"><img src="https://opencollective.com/cucumber/backer/7/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/backer/8/website" target="_blank"><img src="https://opencollective.com/cucumber/backer/8/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/backer/9/website" target="_blank"><img src="https://opencollective.com/cucumber/backer/9/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/backer/10/website" target="_blank"><img src="https://opencollective.com/cucumber/backer/10/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/backer/11/website" target="_blank"><img src="https://opencollective.com/cucumber/backer/11/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/backer/12/website" target="_blank"><img src="https://opencollective.com/cucumber/backer/12/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/backer/13/website" target="_blank"><img src="https://opencollective.com/cucumber/backer/13/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/backer/14/website" target="_blank"><img src="https://opencollective.com/cucumber/backer/14/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/backer/15/website" target="_blank"><img src="https://opencollective.com/cucumber/backer/15/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/backer/16/website" target="_blank"><img src="https://opencollective.com/cucumber/backer/16/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/backer/17/website" target="_blank"><img src="https://opencollective.com/cucumber/backer/17/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/backer/18/website" target="_blank"><img src="https://opencollective.com/cucumber/backer/18/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/backer/19/website" target="_blank"><img src="https://opencollective.com/cucumber/backer/19/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/backer/20/website" target="_blank"><img src="https://opencollective.com/cucumber/backer/20/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/backer/21/website" target="_blank"><img src="https://opencollective.com/cucumber/backer/21/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/backer/22/website" target="_blank"><img src="https://opencollective.com/cucumber/backer/22/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/backer/23/website" target="_blank"><img src="https://opencollective.com/cucumber/backer/23/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/backer/24/website" target="_blank"><img src="https://opencollective.com/cucumber/backer/24/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/backer/25/website" target="_blank"><img src="https://opencollective.com/cucumber/backer/25/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/backer/26/website" target="_blank"><img src="https://opencollective.com/cucumber/backer/26/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/backer/27/website" target="_blank"><img src="https://opencollective.com/cucumber/backer/27/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/backer/28/website" target="_blank"><img src="https://opencollective.com/cucumber/backer/28/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/backer/29/website" target="_blank"><img src="https://opencollective.com/cucumber/backer/29/avatar.svg"></a>

## Sponsors

Become a sponsor and get your logo on our README on Github with a link to your site. [[Become a sponsor](https://opencollective.com/cucumber#sponsor)]

<a href="https://opencollective.com/cucumber/sponsor/0/website" target="_blank"><img src="https://opencollective.com/cucumber/sponsor/0/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/sponsor/1/website" target="_blank"><img src="https://opencollective.com/cucumber/sponsor/1/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/sponsor/2/website" target="_blank"><img src="https://opencollective.com/cucumber/sponsor/2/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/sponsor/3/website" target="_blank"><img src="https://opencollective.com/cucumber/sponsor/3/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/sponsor/4/website" target="_blank"><img src="https://opencollective.com/cucumber/sponsor/4/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/sponsor/5/website" target="_blank"><img src="https://opencollective.com/cucumber/sponsor/5/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/sponsor/6/website" target="_blank"><img src="https://opencollective.com/cucumber/sponsor/6/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/sponsor/7/website" target="_blank"><img src="https://opencollective.com/cucumber/sponsor/7/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/sponsor/8/website" target="_blank"><img src="https://opencollective.com/cucumber/sponsor/8/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/sponsor/9/website" target="_blank"><img src="https://opencollective.com/cucumber/sponsor/9/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/sponsor/10/website" target="_blank"><img src="https://opencollective.com/cucumber/sponsor/10/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/sponsor/11/website" target="_blank"><img src="https://opencollective.com/cucumber/sponsor/11/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/sponsor/12/website" target="_blank"><img src="https://opencollective.com/cucumber/sponsor/12/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/sponsor/13/website" target="_blank"><img src="https://opencollective.com/cucumber/sponsor/13/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/sponsor/14/website" target="_blank"><img src="https://opencollective.com/cucumber/sponsor/14/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/sponsor/15/website" target="_blank"><img src="https://opencollective.com/cucumber/sponsor/15/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/sponsor/16/website" target="_blank"><img src="https://opencollective.com/cucumber/sponsor/16/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/sponsor/17/website" target="_blank"><img src="https://opencollective.com/cucumber/sponsor/17/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/sponsor/18/website" target="_blank"><img src="https://opencollective.com/cucumber/sponsor/18/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/sponsor/19/website" target="_blank"><img src="https://opencollective.com/cucumber/sponsor/19/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/sponsor/20/website" target="_blank"><img src="https://opencollective.com/cucumber/sponsor/20/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/sponsor/21/website" target="_blank"><img src="https://opencollective.com/cucumber/sponsor/21/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/sponsor/22/website" target="_blank"><img src="https://opencollective.com/cucumber/sponsor/22/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/sponsor/23/website" target="_blank"><img src="https://opencollective.com/cucumber/sponsor/23/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/sponsor/24/website" target="_blank"><img src="https://opencollective.com/cucumber/sponsor/24/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/sponsor/25/website" target="_blank"><img src="https://opencollective.com/cucumber/sponsor/25/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/sponsor/26/website" target="_blank"><img src="https://opencollective.com/cucumber/sponsor/26/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/sponsor/27/website" target="_blank"><img src="https://opencollective.com/cucumber/sponsor/27/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/sponsor/28/website" target="_blank"><img src="https://opencollective.com/cucumber/sponsor/28/avatar.svg"></a>
<a href="https://opencollective.com/cucumber/sponsor/29/website" target="_blank"><img src="https://opencollective.com/cucumber/sponsor/29/avatar.svg"></a>
